
#include <p33FXXXX.h>
#include "my_define.h"
#include <uart.h>
#include <spi.h>
#include <math.h>
#include <qei.h>

/*************************************************/
// ADC1 ҲժlưƵ{
//
/*************************************************/
void	Initial_AD1_DMA0(void)
{
	AD1CON1 = 	0x30E4 ;		// 0b0011 0000 1110 0100
	AD1CON2 = 	0x0408 ;		// 0b0000 0100 0000 1000
	AD1CON3 = 	0x9008 ;
	AD1CON4 = 	0x0000 ;
	AD1CHS123 = 0x0000 ;
	AD1CHS0 =  	0x0009 ;
	AD1CSSH = 	0x0000 ;
	AD1CSSL = 	0x0000 ;
	
	AD1PCFGL = 0xffff ;
	AD1PCFGH = 0xffff ;
	AD2PCFGL = 0xffff ;

	AD1CSSLbits.CSS8 = 1 ;
	AD1CSSLbits.CSS9 = 1 ;
	AD1CSSLbits.CSS10 = 1 ;
	AD1PCFGLbits.PCFG8 = 0 ;			// RB8 as Analog input for SW1 .. SW4
	AD1PCFGLbits.PCFG9 = 0 ;			// RB9 as Analog input ::
	AD1PCFGLbits.PCFG10 = 0 ;			// RB9 as Analog input ::
	AD1CON1bits.ADON = 1 ;

	// Initialize DMA

	DMACS0 = 0x0000 ;
	DMA0CON = 0x0000 ;
	DMA0REQ = 0x000d ;
	DMA0STA = 0x0000 ;
	DMA0PAD = ( volatile unsigned int ) & ADC1BUF0 ;
	DMA0CNT = 0x0002 ;
	IFS0bits.DMA0IF = 0 ;
	IEC0bits.DMA0IE = 1 ;
	DMA0CONbits.CHEN = 1 ;
	IFS0bits.AD1IF = 0 ;
}


void	Initial_OC6(void)
{
		OC6CON = 0b0010000000001110 ;	// Set as PWM Mode , Timer3 as time base 
		OC6R = 0x00 ;
		OC6RS = 2500 ;					// 1/2 * PR3 ( PR4 = 5000 )
}

void	Initial_TMR3(void)
{
		T3CON = 0x00 ;
		TMR3 = 0x00 ;
		PR3 = 5000 ;
		T3CONbits.TON = 1 ;
		IEC0bits.T3IE = 0 ;
}

/*************************************************/
// QEIҲժlưƵ{
//
/*************************************************/
void Initial_QEI(void)
{
	
	ConfigIntQEI(QEI_INT_DISABLE&QEI_INT_PRI_0) ;

	OpenQEI( 	QEI_MODE_x4_MATCH & QEI_IDLE_CON &				// ]w4ҦAm~ާ@
				QEI_INPUTS_NOSWAP & QEI_NORMAL_IO &				// Ow]}A`XJ
		     	QEI_INDEX_RESET_DISABLE & QEI_DIR_SEL_CNTRL ,	// Эm\AVܱ]w
			 	QEI_QE_CLK_DIVIDE_1_4 & QEI_QE_OUT_DISABLE ) ;
			 
}

/*************************************************/
// Timer1 ҲժlưƵ{
//
/*************************************************/
void	Initial_TMR1(void)
{

		T1CON = 0x00 ;
		TMR1 = 0x00 ;
		PR1 = 5312/2 ;
		T1CONbits.TON = 1 ;
		IEC0bits.T1IE = 1 ;
}

/*************************************************/
// Timer2 ҲժlưƵ{
//
/*************************************************/
void	Initial_TMR2(void)
{

		T2CON = 0b0000000000010000 ;		// Prescaler = 1:8
		TMR2 = 0x00 ;
		PR2 = 10000 ;						// 5000us@ 16Mhz Fosc with 1:8 prescaler = 5ms
		T2CONbits.TON = 1 ;
		IEC0bits.T2IE = 1 ;
}


void	Initial_UART1(void)
{

		U1MODE = 0x8800 ;
		U1STA = 0x2400 ;
		U1BRG =51 ;					// Baud-Rate = 19200 when Fcy = 16M , BRGH = 0 

		Ctrl_U1RX = INPUT ;
		Ctrl_U1TX = OUTPUT ;
	
}

void	Initial_SPI(void)
{
	unsigned int 	config1 , config2 ;

	SPI_CS = 1 ;									//	Inactive CS
	DAC_SHDN = 1 ;
	DAC_LOAD = 1 ;
	DIR_SPI_CS = 0 ;
	DIR_DAC_SHDN = 0 ;
	DIR_DAC_LOAD = 0 ;
	
	SPI1CON1 = 0x007d ;								//	0010 0010 0111 1101
	SPI1CON2 = 0b0000000000000000 ;
	SPI1STAT = 0xa000 ;								//	1010 0000 0000 0000
	
	ConfigIntSPI1(SPI_INT_DIS & SPI_INT_PRI_4) ;

}


void	Initial_UART2(void)
{

		U2MODE = 0x8800 ;
		U2STA = 0x2400 ;
		U2BRG = 51 ;						// Baud-Rate = 19200 when Fcy = 16M , BRGH = 0 

		Ctrl_U2RX = INPUT ;
		Ctrl_U2TX = OUTPUT ;
}
